<?php
#   <set name='Critical' value='0' color='FF0000' />

$logFile = file("/var/spool/qscan/quarantine.log");
//$fp = fopen("fusioncharts/data.xml", "w");


// Legacy from the old anti-virus only stats
//fwrite ($fp, "<graph  caption='Total Blocked by Month' xAxisName='' yAxisName='' showNames='1' decimalPrecision='0' formatNumberScale='0' pieSliceDepth='20' pieRadius='55'> \n");

while (list($key, $val) = each($logFile)) {
  $val = explode("\t",$val);

  $date = strtotime($val[0]);

  # Remove the user@domain. of the mails 
  # ART- what do we do with this?
  $domain = explode("@",$val[1]);

  $data[] = $date."\t".$domain[1]."\t".$val[4];
  #print " $date  $domain[1] $val[4] \n";

  $i++;

}

# Total viruses caught
$count = count($data);
$startTable = 1;
$rDom = array();
$rVir = array();


# last 12 months
for ($i = 0; $i < 12; $i++) {
  $now = time();
  $dM = date("n",$now);
  $dY = date("Y",$now);
  if ($dM <= $i) {
    $dM = 12-($i-$dM);
    $dY = $dY-1;
  } else {
    $dM = $dM-$i;
  }

  $min = strtotime("$dM/1/$dY 00:00:00");

  $dD = date("t",$min);
  $max = strtotime("$dM/$dD/$dY 23:59:59");

  # Look for a time limit
  if (($dY == $config["startYear"]) AND ($dM == $config["startMonth"])) {
    $startTable = 12-$i;
  }

  # Check all records and takes out data to use
  $datas = array();
  reset($data);
  while (list($key, $val) = each($data)) {
    # Explode each line
    $line = explode("\t",$val);
    # Check the date
    if (($line[0] >= $min) AND ($line[0] <= $max)) {
      $datas[] = $val;
    }
  }

  # Generate the result line
  $rTotal = count($datas);

  # These are the totals for each month
  $month = date("M", mktime(0, 0, 0, $dM));
  $monthly_summary[] = "<set name='$month' value='$rTotal' color='FF0000' />"; 

  $rDaily = number_format(($rTotal / $dD), 2);
  unset($dDom);
  unset($dVir);
  while (list($key, $val) = each($datas)) {

    # Explode each line
    $line = explode("\t",$val);

    # Count the domains
    $dDom[$line[1]]++;
    $ext = explode(".",$line[1]);
    end($ext);
    $ext = strtolower(current($ext));
    $rDom[$ext]++;

    # Count the viruses
    $dVir[$line[2]]++;
    $rVir[$line[2]]++;

  }

  $rrDom = count($dDom);
  $rrVir = count($dVir);
  $key = 12-$i;
  $kM = $dM;
  $dM = date("M",$max);
  $result[$key] = array("Month" => $dM, "Year" => $dY, "Daily" => $rDaily, "Viruses" => $rrVir, "Domains" => $rrDom, "Total" => $rTotal, "Mcode" => $kM);


}

//$monthly_summary = array_reverse ($monthly_summary);
//foreach ($monthly_summary as $line) {
//  fwrite ($fp,"$line \n");
//}


//fwrite ($fp, "</graph> \n");


$fp = fopen("/usr/local/psa/admin/htdocs/atomic-scanner/summary.html", "w");
$color="#ffffff";
fwrite ($fp, "
  <table width=700>
    <tr bgcolor='#ffffff'>
      <td><b>Month</b></td>
      <td><b>Daily Average</b></td>
      <td><b>Viruses</b></td>
      <td><b>Sources</b></td>
      <td><b>Monthly Total</b></td>
    </tr>
  ");
#colors: #eef0fc and #ffffff
for ($i = $startTable; $i <= 12; $i++) {
  if ($color == "#ffffff") {
    $color="#eef0fc";
  } else if ($color ="#eef0fc") { 
    $color="#ffffff";
  }
  fwrite( $fp, "<tr bgcolor=".$color."><td>" .
        $result[$i][Month]." ". $result[$i][Year]. "</td><td>" . 
        $result[$i][Daily] . "</td><td>" .
        $result[$i][Viruses] . "</td><td> " .
        $result[$i][Domains] . "</td><td> " .
        $result[$i][Total] . "</td>" .
  "</tr>\n"); 

}
fwrite ($fp, "</table>\n");


# This put forth the total viruses for jul (this month)
#print($result[$i][Viruses]);

arsort($rDom);
arsort($rVir);

$fp = fopen("/usr/local/psa/admin/htdocs/atomic-scanner/fusioncharts/data-pie.xml", "w");

fwrite ($fp, "<graph caption='Virus by Total' xAxisName='' yAxisName='' showNames='1' decimalPrecision='0' formatNumberScale='0' pieSliceDepth='20' pieRadius='75' showPercentageInLabel='1'>");


$i=1;
reset($rVir);

$color_array=array('null','ff0000','fff600','00ff0c','d637f3','9d9d9d','ffc90d','ff94ea','cb3080','6659ab', '0d1eff');

while ($i <= 10) {
  if (key($rVir) <> "") {
    $n=key($rVir);
  } else {
    $n = "Unknown";
  }
    
  $total_virus = current($rVir);
  #print "DEBUG: $total_virus $n $color_array[$i] \n";
  fwrite ($fp, "<set name='$n' value='$total_virus' color='$color_array[$i]' link='n-http://www.atomicorp.com/wiki/index.php/$n' /> \n");
  next($rVir);
  $i++;
}

fwrite ($fp, "</graph>");

// New stuff
ini_set("memory_limit","943M");
$logFile = file("/var/asl/tmp/atomic-scanner.log");
$total=0;
$virus=0;
$spam=0;
$policy=0;



while (list($key, $val) = each($logFile)) {
  //if (/(^.*) \S+:\d+:(.*Process)/) {
  if (preg_match("/(^.*) \S+:\d+: (.*)/", $val, $result)) {
   $date = strtotime($result[1]);
   //print "DEBUG: $result[1] \n";
   //print "DEBUG1: $result[2] \n";
   //print "DEBUG2: $date \n";

   if (preg_match("/.*Process/", $result[2])) {
     $total++;
     $data[]=$date."\tProcessed";
   } else if (preg_match("/.*here be a virus/", $result[2])) {
     $virus++;
     $data_virus[]=$date."\tvirus";
   } else if (preg_match("/.*SA: yup, this smells /", $result[2])) {
     $spam++;
     $data_spam[]=$date."\tspam";
   } else if (preg_match("/.*q_s: Policy BLOCK/", $result[2])) {
     $policy++;
     $data_policy[]=$date."\tpolicy";
   }

  }

}
for ($i = 0; $i < 12; $i++) {
        $now = time();
        $dM = date("n",$now);
        $dY = date("Y",$now);
        if ($dM <= $i) {
                $dM = 12-($i-$dM);
                $dY = $dY-1;
        } else {
                $dM = $dM-$i;
        }
        $min = strtotime("$dM/1/$dY 00:00:00");
        $dD = date("t",$min);
        $max = strtotime("$dM/$dD/$dY 23:59:59");

      # Check all records and takes out data to use
        $datas = array();
        reset($data);

      # Count up the stats for this month
        while (list($key, $val) = each($data)) {

                # Explode each line
                $line = explode("\t",$val);

                # Check the date
                if (($line[0] >= $min) AND ($line[0] <= $max)) {
                        $datas[] = $val;
                }

        }
        $rTotal = count($datas);
        $rDaily = number_format(($rTotal / $dD), 2);
  # Count the virus'
        $datas_virus = array();
        reset($data_virus);
        while (list($key, $val) = each($data_virus)) {
               # Explode each line
                $line = explode("\t",$val);

                # Check the date
                if (($line[0] >= $min) AND ($line[0] <= $max)) {
                        $datas_virus[] = $val;
                }

        }
        $rTotal_virus = count($datas_virus);
        $rDaily_virus = number_format(($rTotal_virus/ $dD), 2);

  # Count the spam
        $datas_spam = array();
        reset($data_spam);
        while (list($key, $val) = each($data_spam)) {
               # Explode each line
                $line = explode("\t",$val);

                # Check the date
                if (($line[0] >= $min) AND ($line[0] <= $max)) {
                        $datas_spam[] = $val;
                }

        }
        $rTotal_spam = count($datas_spam);
        $rDaily_spam = number_format(($rTotal_spam/ $dD), 2);
  # Count the policy blocks
        $datas_policy = array();
        reset($data_policy);
        while (list($key, $val) = each($data_policy)) {
               # Explode each line
                $line = explode("\t",$val);

                # Check the date
                if (($line[0] >= $min) AND ($line[0] <= $max)) {
                        $datas_policy[] = $val;
                }

        }
        $rTotal_policy = count($datas_policy);
        $rDaily_policy = number_format(($rTotal_policy/ $dD), 2);





        $dM = date("M",$max);

  $out_month[] = $dM ;
  $out_virus[] = $rTotal_virus;
  $out_spam[] = $rTotal_spam;
  $out_policy[] = $rTotal_policy;
  $out_mail[] = $rTotal;
}

$out_month= array_reverse($out_month);
$out_virus= array_reverse($out_virus);
$out_spam= array_reverse($out_spam);
$out_mail= array_reverse($out_mail);

// Write to file

$fp = fopen("/usr/local/psa/admin/htdocs/atomic-scanner/fusioncharts/data-multi.xml", "w");


# Months
fwrite ($fp,"
<graph caption='Scanner Statistics' PYAxisName='Malware/Spam Volume' SYAxisName='Mail Volume' showvalues='0' numDivLines='4' formatNumberScale='0' decimalPrecision='0' anchorSides='10' anchorRadius='3' anchorBorderColor='009900'>

<categories> \n");
while (list($key, $val) = each($out_month)) {
  fwrite ($fp, "<category name='$val'/> \n");
}
fwrite ($fp, "
</categories>\n
<dataset seriesName='Virus' color='FF0000' showValues='0'> \n
");

# Virus
while (list($key, $val) = each($out_virus)) {
  fwrite ($fp, "<set value='$val'/> \n");
}
fwrite ($fp, "
</dataset>\n
<dataset seriesName='Spam' color='F6BD0F' showValues='0'>
");

# Spam
while (list($key, $val) = each($out_spam)) {
  fwrite ( $fp, "<set value='$val'/> \n");
}
fwrite ($fp, "
</dataset>\n
<dataset seriesName='Total Mail' color='8BBA00' showValues='0' parentYAxis='S'>
");

# Total mail
while (list($key, $val) = each($out_mail)) {
  fwrite ($fp, "<set value='$val'/> \n");
}
fwrite ($fp, "
</dataset>\n
</graph>\n
");



?>
